feldspar-language-0.6.0.2: A functional embedded language for DSP and parallelism

Safe Haskell | None

Feldspar.Core.Interpretation.Typed

Description

Witness `Type` constraints

Synopsis

- class Typed dom where
  - typeDictSym :: dom a -> Maybe (Dict (Type (DenResult a)))
- typeDict :: Typed dom => ASTF dom a -> Maybe (Dict (Type a))

# Documentation

class Typed dom where

Class representing a possible dictionary to witness a `Type` constraint.

Methods

typeDictSym :: dom a -> Maybe (Dict (Type (DenResult a)))

Instances

Typed dom |
Typed Empty |
Typed Mutable |
Typed MutableToPure |
Typed sub => Typed (Decor info sub) |
Typed sub => Typed (:| sub pred) |
Typed sub => Typed (:|| sub pred) |
Typed (:|| sub Type) |
(Typed sub, Typed sup) => Typed (:+: sub sup) |
Typed (SubConstr2 c sub Type Top) |

typeDict :: Typed dom => ASTF dom a -> Maybe (Dict (Type a))

Extract a possible `Type` constraint witness from an `AST`